見積書
===========

見積書のサンプルです。

テーブル形式の明細項目を持っています。

ファイルの内容
--------------
- hyousi.ods  
    見積書表紙の元原稿（OpenOffice.org形式）
- hyousi.pdf  
    見積書表紙のPDFテンプレート
- mitumori.odt  
    見積書の元原稿（OpenOffice.org形式）
- mitumori.pdf  
    PDFテンプレート
- stamp.png  
    印影画像
- mitumori1.json  
    １枚構成帳票のレンダリング・パラメータ（JSON形式）
- mitumori2.json  
    表紙＋本体の２枚構成帳票のレンダリング・パラメータ（JSON形式）
- mitumori3.json  
    複数枚構成帳票のレンダリング・パラメータ（JSON形式）
- mitumori4.json  
    表紙＋明細（複数枚）構成帳票のレンダリング・パラメータ（JSON形式）

ポイント1
--------

- 単票の場合は，template要素の値として，テンプレートのパス名を直接指定すること
  ができます。
- フィールドの値はすべて文字列で指定し，その値がそのまま出力されています。
- ボタンフィールドには，iconエントリにより，画像ファイルを指定できます。
- 0, 1, 2,…と命名されたテーブル形式のフィールドでは，配列を利用することで，部
  分フィールド名の指定を省略できます。
- 「御見積金額合計」と「税込合計」の欄は，同名のフィールド“total”を配置する
  ことで，context要素の指定が１箇所で済んでいます。
  
ポイント2
--------

- 表紙に“header”, 本体に“body”という名前をつけることで，フィールドの名前空
  間を分離しています。
- 名前空間を挿入した分，context要素の階層を１段深くする必要があります。
- 日付の値として環境変数NOWを指定することで，現在日付を取得しています。
- 数値項目の値を数値とし，style要素により数値の書式を指定しています。
- style要素では，ワイルドカードを使うことで，復数フィールドに対して一括して
  styleの指定を行っています。

ポイント3
--------

- 明細テーブルの行数応じてページ数を増やすタイプの帳票を連続帳票と呼びます。
- 連続帳票では，PDFテンプレートの名称を“*”とします。
- “rows”エントリにより，テーブルの最大の行数を指定します。
- context要素の値は，リスト（配列）形式になります。
- tableの値としてテーブルの最大行数を超えるデータを与えると，自動的に必要な
  ページ数に分割します。
- フィールドに「複数行」の指定がなされている場合，文字列中の“\n”の位置で改行
  します。
- 2ページ目以降の印影と備考欄を非表示にしています。
- 1行おきに背景色を変えるstyle指定を行っています。

ポイント4
--------

- 複合帳票と連続帳票を合わせる場合は，連続帳票部分の名前空間を“body.*”のよう
  に1段階層を深くします。
- property辞書により，出力されるPDFに文書情報を付与しています。
  
実行方法
--------

コマンドライン:

    $ reports render mitumori1.json out1.pdf
    $ reports render mitumori2.json out2.pdf
    $ reports render mitumori3.json out3.pdf
    $ reports render mitumori4.json out4.pdf
